/************************************************
              Class Node

A minimal Node class for use within the LinkedList 
class of the 15-111/200 Mastery Exam/Fall 2002

Students are not permitted to modify or augment
this class in any way. This file must not change.

Exam for 15-111/200  Fall 2002

*************************************************/


/**
*  A object of the class, Node has an object that contains a reference
*  to an object of type Comparable and a reference to another Node. 
*  Allows a Node to be inserted into a list at construction. Supports 
*  linking a subsequent object to this Node, will return the reference 
*  to the next Node, or the reference to the data Object. However, 
*  <b>the data object is immutable once  the object is constructed.</b>
*
*  <b>Students are not allowed to modify this class</b>
*/


public class Node implements Comparable
{

   private Comparable value;
   private Node next;

   /**
   *  Constructor builds the Node with the supplied parameter
   *  @param data initValue must be of type Comparable
   */
   public Node(Comparable initValue)
   {
      this(initValue, null);
   }

   /**
   *  Constructor builds the Node with the supplied parameters
   *  @param initValue must be of type Comparable
   *  @param link  to a next Node, or null
   */
   public Node(Comparable initValue, Node initNext)
   {
      value = initValue;
      next = initNext;
   }

   /**
   *  Returns reference to the next Node
   *  @return next reference
   */
   public Node getNext()
   {
      return next;
   }

   /**
   *  Sets the next reference of this object to the paramter object
   *  @param newNodde which is an object of the class Node
   */
   public void setNext(Node newNode)
   {
      next = newNode;
   }

   /**
   *  Returns reference to the data value of the object
   *  @return Comparable reference
   */

   public Comparable getData()
   {
      return value;
   }

   /**
   *  Compares value of Node to the parameter and returns:
   *  -1 if the Node is less than the parameter,
   *   0 if the Node is equal to the parameter, and
   *   1 if the Node is greater than the parameter
   *  @return 1, 0, or -1
   */
   public int compareTo(Object obj)
   {
       return (getData().compareTo(((Node)obj).getData()));
   }

   /**
   *  Returns string representation of the object
   *  @return String reference
   */
   public String toString()
   {
      return value.toString();
   }
}
